---
title: Xamarin.Android error XA1011
description: XA1011 error code
ms.date: 04/03/2020
---
# Xamarin.Android error XA1011

## Example messages

```
error XA1011: Using ProGuard with the D8 DEX compiler is no longer supported. Please update `$(AndroidLinkTool)` to `r8`.
```

## Issue

The project has `$(AndroidDexTool)` set to `d8` and `$(AndroidLinkTool)` set to
`ProGuard`.  In the past this configuration was allowed, but now only the R8
code shrinker is supported for use with the D8 DEX compiler.

## Solution

Update the `$(AndroidLinkTool)` MSBuild property to `r8` to select the R8 code
shrinker.  This property corresponds to the **Code shrinker** setting in the
Visual Studio project properties pages.

R8 might in some cases produce new build warnings or errors compared to
ProGuard, so the ProGuard rules for the project might require a few updates to
resolve any new warnings or errors that appear after this change.
